% The neural gas algorithm for vector quantization
%
% Standard usage:
%
% [C, labels, mse]=NG(X, codebook_size, epochs);
%
%function [C, labels, mse]=NG(X, codebook_size, epochs, alpha0, lambda0);
%
%Input:
%   X : data (one sample per column)
%   codebook_size : number of clusters
%   epochs : number of training epochs (number of training iterations = epochs *  size of data)
%   alpha0 : initial learining rate (optional)
%   lambda0 : initial neighbourhood-size (optional)
%
%Output:
%   C : codebook vectors (cluster centers)
%   labels : assignment of data samples and codebook vectors
%   mse : mean squared representation error
% 
function [C, labels, mse]=NG(X, codebook_size, epochs, alpha0, lambda0);
