#ifndef DISK_UTILS_H_INCLUDED
#define DISK_UTILS_H_INCLUDED

#include<stdio.h>

int exist(char* filename);

int parse_data (double*** M, int* entry_size, int* num_entrys, char* filename, int reorganize, int* use_info, int use_info_size, double* file_index);

double* parse_string (char* str, int* len);

double** load_data (char* filename, int* entry_size, int* num_entrys, int reorganize, int* use_infoi=NULL, int use_info_size=0, double* file_index=NULL, int output=1);

int save_data (char* filename, double** M, int entry_size, int nentrys);
int save_int_data (char* filename, int** M, int rows, int columns);

double** split_data (double** D, int D_rows, int D_columns, double** c);

char** get_files (char* dirname, int* num_files);

int match(const char *string, char *pattern);

char** str_sort (char** str, int len);

char** filter (char** str, int len, char* pattern, int* new_len);

double* create_file_index (char* filename, int* index_length);

int get_bin_file_size(char* filename, int* num_rows, int* num_columns, int* clength, int* entry_size);

int get_bytes(char* dest, FILE* file, int clen, int tcolumn, int offset, int read_bytes);
int put_bytes(FILE* file, char* src, int clen, int tcolumn, int offset, int write_bytes);

#endif
