/*
(Soft)MaxMinOver learning algorithm written by Kai Labusch
Copyright (C) 2004 Kai Labusch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact:
labusch@inb.uni-luebeck.de
*/


#ifndef __MIN_H_INCLUDED__
#define __MIN_H_INCLUDED__

/**
	Y: on return: the k smallest values in X
	I: on return: the indices of the values in Y with regard to X
	X: complete set of values
	x_size: size of X
	k: number of smallest values to be found
*/
int kmin (double* Y, int* I, double* X, int x_size, int k);

int heap_insert (double* H, int* I, double x, int x_I, int used);
void heapify (double* H, int* I, int index, int used);
int heap_extract_max (double* H, int* I, int used);

#endif
