#ifndef __NGAS_H_INCLUDED__
#define __NGAS_H_INCLUDED__

class DataDesc;

double** ngas(double** X, int X_columns, int ssize, int codebook_size, int epochs, double alpha0, double lambda0, double** r_labels);

double** spngas(DataDesc* data, int codebook_size, int epochs, int num_components,
		double alpha0, double lambda0, double alphaf, double lambdaf, double noise_level, int t_start, int t_max, 
		double* E, double* N0, double* AE, double** A_orig, double*** track_codebook,
		int num_track, int operation_mode, double** initial_codebook);

void omp (DataDesc* P, double*** r_R, double** r_N0, double** r_NR, 
	  int num_components, double noise_level, DataDesc* data, double*** codebooks, int num_codebooks, int codebook_size);

int bop(double**** r_P, double**** r_R, 
	  double** C, int num_components, double noise_level, DataDesc* data, int codebook_size, int* schedule, int n_desired, int use_dc_component, int nonnegative, int output=0);



#define OPERATION_MODE_BATCH 0
#define OPERATION_MODE_ONLINE 1

#endif
